program MappingExample;

	uses
{$ifc undefined THINK_Pascal}
		Types, Files, Packages, Aliases, 
{$endc}
		ICTypes, ICAPI, ICKeys, ICSubs, ICMappings;

	var
		inst: ICInstance;

	procedure DumpMappings (mappings: handle);
		var
			err: OSErr;
			entry: ICMapEntry;
			pos: longInt;
	begin
		pos := 0;
		err := ICMGetEntry(mappings, pos, entry);
		while err = noErr do begin
			writeln(entry.total_length : 1, ' ', entry.fixed_length : 1, ' ', entry.version : 1, ' ', entry.file_type, ' ', entry.file_creator, ' ', entry.flags : 1, ' "', entry.extension, '" "', entry.creator_app_name, '" "', entry.MIME_type, '"');
			pos := pos + entry.total_length;
			err := ICMGetEntry(mappings, pos, entry);
		end;
	end;

	var
		folder_spec: ICDirSpecArray;
		email_address: Str255;
		attr: longint;
		size: longint;
		seed: longint;
		mappings: handle;
		entry: ICMapEntry;
begin
{$ifc not undefined THINK_Pascal}
	ShowText;
{$endc}
	writeln('ICStart: ', ICStart(inst, 'CREA') : 1);		(* tell it your application creator *)
	writeln('ICFindConfigFile: ', ICFindConfigFile(inst, 0, nil) : 1);

	writeln('ICBegin: ', ICBegin(inst, icReadWritePerm) : 1);

	mappings := NewHandle(0);
	writeln('ICGetPrefHandle: ', ICGetPrefHandle(inst, kICMapping, attr, mappings) : 1);

	entry.file_type := 'TEXT';
	entry.file_creator := 'MPS ';
	entry.flags := 0;
	entry.extension := '.txt';
	entry.creator_app_name := 'MPW Shell';
	entry.MIME_type := 'text/text';
	writeln('ICMAddEntry: ', ICMAddEntry(mappings, entry) : 1);

	entry.file_type := 'TEXT';
	entry.file_creator := 'R*ch';
	entry.flags := 0;
	entry.extension := '.text';
	entry.creator_app_name := 'BBEdit';
	entry.MIME_type := 'text/text';
	writeln('ICMSetEntry: ', ICMSetEntry(mappings, 0, entry) : 1);

	writeln('ICSetPrefHandle: ', ICSetPrefHandle(inst, kICMapping, ICattr_no_change, mappings) : 1);

	DumpMappings(mappings);

	writeln('ICEnd: ', ICEnd(inst) : 1);

	writeln('ICStop: ', ICStop(inst));
end. (* MappingExample *)